' Beispiel fr Labyrinth-Spiel
' Beilage zu http://forum.qbasic.at/viewtopic.php?t=5323
' nderung 08.03.2008: - Perlen zum Einsammeln
'                      - Score

DECLARE SUB TitelAusgabe (t$, h%, f%)
DECLARE FUNCTION FuehrNull$ (w%, b%)
DECLARE SUB GibPunkteAus ()
DECLARE SUB GibPerlenAus ()

DIM SHARED score%, restPerl%
DIM lev%(1 TO 39, 1 TO 24)

SCREEN 0
WIDTH 40, 25

DO
  COLOR 7, 0
  CLS
  TitelAusgabe "Spieltitel", 3, 9
  TitelAusgabe "Start mit Leertaste", 4, 14
  TitelAusgabe "Ende mit Esc", 5, 2
  DO
    t$ = INKEY$
  LOOP WHILE t$ = ""
  IF t$ = " " THEN
    ' Spiel
    level% = 1
    score% = 0
    DO
      COLOR 7, 0
      CLS
      TitelAusgabe "Level" + STR$(level%), 13, 15
      d$ = INPUT$(1)
      restPerl% = 0
      OPEN "level" + LTRIM$(STR$(level%)) + ".txt" FOR INPUT AS 1
      FOR i% = 1 TO 24
        LINE INPUT #1, z$
        LOCATE i%, 1
        FOR j% = 1 TO 39
          SELECT CASE MID$(z$, j%, 1)
          CASE "*"
            ' Mauer
            lev%(j%, i%) = 1
            COLOR 12, 5
            PRINT "";
          CASE " "
            ' Leer
            lev%(j%, i%) = 0
            COLOR 7, 0
            PRINT " ";
          CASE "P"
            ' Perle
            lev%(j%, i%) = 2
            restPerl% = restPerl% + 1
            COLOR 11, 0
            PRINT CHR$(4);
          CASE "S"
            ' Startpunkt
            lev%(j%, i%) = 0
            COLOR 14, 0
            PRINT CHR$(2);
            xPos% = j%
            yPos% = i%
          CASE "Z"
            ' Zielpunkt
            lev%(j%, i%) = 3
            COLOR 9, 1
            PRINT CHR$(127);
          CASE ELSE
            ' nicht definiert (sollte nicht vorkommen)
            lev%(j%, i%) = 2
            COLOR 7, 0
            PRINT "?"
          END SELECT
        NEXT j%
      NEXT i%
      CLOSE 1
      LOCATE 25, 1
      COLOR 7, 0
      PRINT "Level:??? Punkte:????? Perlen:???";
      COLOR 15
      LOCATE 25, 7
      PRINT FuehrNull$(level%, 3);
      GibPunkteAus
      GibPerlenAus
      komplett% = 0
      DO
        DO
          t2$ = INKEY$
        LOOP WHILE t2$ = ""
        SELECT CASE t2$
        CASE CHR$(0) + "H"
          xPos1% = xPos%
          yPos1% = yPos% - 1
        CASE CHR$(0) + "K"
          xPos1% = xPos% - 1
          yPos1% = yPos%
        CASE CHR$(0) + "M"
          xPos1% = xPos% + 1
          yPos1% = yPos%
        CASE CHR$(0) + "P"
          xPos1% = xPos%
          yPos1% = yPos% + 1
        CASE ELSE
          xPos1% = xPos%
          yPos1% = yPos%
        END SELECT
        SELECT CASE lev%(xPos1%, yPos1%)
        CASE 0, 2
          ' leeres Feld immer frei
          vorwaerts% = -1
        CASE 3
          vorwaerts% = restPerl% = 0
        CASE ELSE
          vorwaerts% = 0
        END SELECT
        ' Hinweis: vorwaerts% wre in einer anderen Sprache Typ Boolean
        IF vorwaerts% THEN
          ' Spielfigur bewegen
          COLOR 14, 0
          LOCATE yPos%, xPos%
          PRINT " ";
          LOCATE yPos1%, xPos1%
          PRINT CHR$(2);
          xPos% = xPos1%
          yPos% = yPos1%
          SELECT CASE lev%(xPos%, yPos%)
          CASE 2
            ' Perle => einsammeln + Punkte
            restPerl% = restPerl% - 1
            score% = score% + 1
            GibPunkteAus
            GibPerlenAus
            lev%(xPos%, yPos%) = 0
            IF restPerl% > 0 THEN
              SOUND 1000, 2
            ELSE
              ' Letzte Perle akustisch untermalen
              PLAY "o3t200l8geceg"
              ' und Ziele blinken lassen
              FOR i% = 1 TO 24
                FOR j% = 1 TO 39
                  IF lev%(j%, i%) = 3 THEN
                    COLOR 31, 1
                    LOCATE i%, j%
                    PRINT CHR$(127);
                  END IF
                NEXT j%
              NEXT i%
            END IF
          CASE 3
            score% = score% + 10
            GibPunkteAus
            LOCATE yPos%, xPos%
            COLOR 14, 1
            PRINT CHR$(1);
            COLOR 10, 0
            LOCATE 13, 15
            PRINT "Level komplett!";
            PLAY "o4t160l8ceg>c<geg"
            komplett% = -1
          END SELECT
        ELSE
          SELECT CASE lev%(xPos1%, yPos1%)
          CASE 3
            ' Zurckhupsound "Noch nicht alle Perlen!"          
            SOUND 90, 9
          CASE ELSE
            ' fr alle brigen Flle (Wand)
            SOUND 600, 1
          END SELECT
        END IF
      LOOP UNTIL t2$ = CHR$(27) OR komplett%
      IF komplett% THEN
        d$ = INPUT$(1)
        level% = level% + 1
      END IF
    LOOP UNTIL t2$ = CHR$(27)
  END IF
LOOP UNTIL t$ = CHR$(27)

SCREEN 0
WIDTH 80, 25

FUNCTION FuehrNull$ (w%, b%)
  ' Zahl mit fhrenden Nullen auf vorgegebene Breite formatieren
  h$ = LTRIM$(STR$(w%))
  FuehrNull$ = STRING$(b% - LEN(h$), "0") + h$
END FUNCTION

SUB GibPerlenAus
  LOCATE 25, 31
  COLOR 15, 0
  PRINT FuehrNull$(restPerl%, 3);
END SUB

SUB GibPunkteAus
  LOCATE 25, 18
  COLOR 15, 0
  PRINT FuehrNull$(score%, 5);
END SUB

SUB TitelAusgabe (t$, h%, f%)
  LOCATE h%, 21 - LEN(t$) \ 2
  COLOR f%
  PRINT t$;
END SUB

